#if !defined( _JWordMakerObj_h )
#define _JWordMakerObj_h
#include "JAddObj.h"
#include "JCriticalSection.h"





class 
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
JWordMakerObj : public JAddObj {
  protected:
  public:
    enum {
      LETTER, BACKSPACE };

    virtual const char* className() const;
    virtual JObject* clone() const;
    JWordMakerObj();
    virtual void draw(JGraphics g, int x, int y, int w, int h);
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void engine(int n, JLinkObj& link);
    virtual int inputType( int n );
    virtual int outputType( int n );
    virtual void access(int n, JLinkObj& link, const JDataType& data);
	virtual JArray getProperties();
	virtual void writeContent( JOutputStream& os );
	virtual void readContent( JDictionary& dict );
	virtual boolean updateProperty( JProperty& prop );
  private:
	  void backspace();
	  bool isdelimiter( char s );
	  int backspaceIndicator;

    // inputs
    JString letter;

    // outputs
    JString word;

	// properties
	int include_capital;
	int include_lowercase;
	int include_digits;
	int include_printable;

	void processText( char* s );
	char internalWord[100];
	int internalWordIdx;
};


#endif
